#pragma once

typedef int fx_s1516;

#include <stdio.h>
#define _USE_MATH_DEFINES
#include <math.h>
#define P2_16 65536.0f
#define e M_E
#define fx_s1516_PI M_PI
#define fx_s1516_INVERSE_PI 1/M_PI
#define degree_to_radian(a) ((a) * M_PI / 180)
#define fx_to_double(a) ((double)(a) / P2_16)
#define double_to_fx(a) ((a) * P2_16)
#define fx_s1516_add(a, b) double_to_fx((a) + (b))
#define fx_s1516_sub(a, b) double_to_fx((a) - (b))
#define fx_s1516_mul(a, b) double_to_fx((a) * (b) * P2_16)
#define fx_s1516_div(a, b) double_to_fx((a) / (b) / P2_16)
#define fx_s1516_sin(a) double_to_fx(sin(a * P2_16) / (P2_16))
#define fx_s1516_sqrt(a) double_to_fx(sqrt(a) / sqrt(P2_16))
#define fx_s1516_pow(a, b) double_to_fx(pow(a, (double)b) * pow(P2_16, (double)b - 1))
#define fx_s1516_log(a, b) double_to_fx(baselog(a * P2_16, b) / (P2_16))


double baselog(double a, double base)
{
	return log(a) / log(base);
}